<?php

namespace App\Http\Controllers;

use App\Models\CentroTrabajo;
use App\Models\Dependencia;
use App\Http\Requests\CentroTrabajoRequest;

/**
 * Class CentroTrabajoController
 * @package App\Http\Controllers
 */
class CentroTrabajoController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        $centroTrabajos = CentroTrabajo::paginate();

        return view('centro-trabajos.index', compact('centroTrabajos'))
            ->with('i', (request()->input('page', 1) - 1) * $centroTrabajos->perPage());
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        $centroTrabajo = new CentroTrabajo();
        // metodo pluck para mandar a traer los datos de categoria de acuerdo al orden
        $dependencias = Dependencia::pluck('nombre', 'id');
        return view('centro-trabajos.create', compact('centroTrabajo', 'dependencias'));
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(CentroTrabajoRequest $request)
    {
        CentroTrabajo::create($request->validated());

        return redirect()->route('centro-trabajos.index')
            ->with('success', 'CentroTrabajo created successfully.');
    }

    /**
     * Display the specified resource.
     */
    public function show($id)
    {
        $centroTrabajo = CentroTrabajo::find($id);
        return view('centro-trabajos.show', compact('centroTrabajo'));
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit($id)
    {
        $centroTrabajo = CentroTrabajo::find($id);
        $dependencias = Dependencia::pluck('nombre', 'id');
        return view('centro-trabajos.edit', compact('centroTrabajo','dependencias'));
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(CentroTrabajoRequest $request, CentroTrabajo $centroTrabajo)
    {
        $centroTrabajo->update($request->validated());

        return redirect()->route('centro-trabajos.index')
            ->with('success', 'CentroTrabajo updated successfully');
    }

    public function destroy($id)
    {
        CentroTrabajo::find($id)->delete();

        return redirect()->route('centro-trabajos.index')
            ->with('success', 'CentroTrabajo deleted successfully');
    }
}
